/*
 * Tractament i publicació d'imatge i vídeo
 * Rosa Suñé Barniol
 * Pràctica 2 - Exercici 4
 * Aplicar màscara de convolució de tipus Sobel 
 * al vídeo Suñé_Rosa_B_1
 * Imoportar els fotogrames del vídeo 
 * Exportar els fotogrames per tornar a muntar el vídeo
 */
 
float[][] centre = {{-1, -2, -1}, 
                    { 0,  0,  0}, 
                    { 1,  2,  1}};
                    
PImage img;

void setup() { 
  size(640, 360);
  img = loadImage("cartell_cine_0.png"); // Carreguem la imatge original
  noLoop();
}

void draw() {
  image(img, 0, 0); // Mostem la imatge en el punt (0,0) 
  img.loadPixels();
  // Creem una imatge opaca de la mateixa mida que la original
  PImage edgeImg = createImage(img.width, img.height, RGB);
  // Recorrem amb un bucle cada píxel de la imatge
  for (int y = 1; y < img.height-1; y++) { // No tenim en compte la fila de pixels 0 superior, no tenen pixel veí
    for (int x = 1; x < img.width-1; x++) { // No tenim en compte les columnes de pixels 0 dreta i esquerra, no tenen pixel veí
      float sum = 0; // Centre sum per cada pixel
      for (int ky = -1; ky <= 1; ky++) {
        for (int kx = -1; kx <= 1; kx++) {
          // Calculem els pixels adjacents per aquest pixel central
          int pos = (y + ky)*img.width + (x + kx);
          // La imatge és en escala de grisos red/green/blue són iguals
          float val = red(img.pixels[pos]);
          // Multipliquem pels pixels adjacents basats en el valor del pixel central
          sum += centre[ky+1][kx+1] * val;
        }
      }
      // Li donem el valor de gris a aquest pixel de la nova imatge 
      // basat en la suma de valors del pixel central
      edgeImg.pixels[y*img.width + x] = color(sum, sum, sum);
    }
  }
  // Actualitzem els canvis a edgeImg.pixels[]
  edgeImg.updatePixels();
  image(edgeImg, 0, 0); //Dibuixem la nova imatge
  save("output-###.png");//La guardem
}